## Workedvanture

## Status

* Deploys via helm
* Backend does not connect to redis
  * Bug report: https://github.com/thecodingmachine/workadventure/issues/1657
* Otherwise, all components are coming up from v3:

```
[14:06] nb3:~% kubectl get pods -l app.kubernetes.io/instance=wa1
NAME                          READY   STATUS    RESTARTS   AGE
wa1-back-5cdf6c477-wpjzn      1/1     Running   0          12m
wa1-coturn-846c5c48bc-cm9n9   1/1     Running   0          37m
wa1-front-7c8d9649f5-68wx2    1/1     Running   0          12m
wa1-icon-5f846d674-hswst      1/1     Running   0          37m
wa1-nginx-78b59f78d8-lgbv7    1/1     Running   0          37m
wa1-pusher-dcbc5f4f5-zh25d    1/1     Running   0          17m
wa1-redis-59b5c9fc5f-m268b    1/1     Running   0          37m
[14:06] nb3:~%
```

## Components

### Back


### Front

### Pusher

### Uploader

### Messages

### Iconserver

## Missing

* Service defintions
* Helm integration


## Other TODO

* Checkout whether traefik can be of help for us, too


## Versions

### v1: all manifests apply in k8s

### v2: all pods run

Problem with the default front container:

```
sudo: unable to send audit message
sudo: pam_open_session: System error
sudo: policy plugin failed session initialization
```

A lot of sudo commands even in the root path:

https://github.com/thecodingmachine/docker-images-nodejs/blob/master/utils/docker-entrypoint-as-root.sh

"fixed" by running as uid 0 and running the entrypoints in container
command.

Messages pod:

```
[11:38] nb3:workadventure% kubectl logs messages-6d5fd6486b-qgdjn
sudo: unable to send audit message
sudo: pam_open_session: System error
sudo: policy plugin failed session initialization
```

* Also has incorrect volumes
* Disable pod/pvc for the moment


### v3: all components work

* Production docker-compose:
  https://github.com/thecodingmachine/workadventure/blob/master/contrib/docker/docker-compose.prod.yaml

back is crashing:

wa1-back-7b59d6b7bb-w4l9j                                         0/1     Error              3          3m26s

```
[13:31] nb3:workadventure% kubectl logs -f wa1-back-7b59d6b7bb-w4l9j
yarn install v1.22.5
[1/4] Resolving packages...
[2/4] Fetching packages...
info fsevents@2.1.3: The platform "linux" is incompatible with this module.
info "fsevents@2.1.3" is an optional dependency and failed compatibility check. Excluding it from installation.
error Could not write file "/usr/src/yarn-error.log": "EACCES: permission denied, open '/usr/src/yarn-error.log'"
error An unexpected error occurred: "EACCES: permission denied, unlink '/usr/src/node_modules/.yarn-integrity'".
info Visit https://yarnpkg.com/en/docs/cli/install for documentation about this command.
[13:32] nb3:workadventure%
```

#### Front does not listen on port 8080:

```
[13:36] nb3:workadventure% curl -v http://wa1-front.default.svc.c2.k8s.ooo:8080
*   Trying 2a0a:e5c0:13:e2::69cc:8080...
* connect to 2a0a:e5c0:13:e2::69cc port 8080 failed: Connection refused
* Failed to connect to wa1-front.default.svc.c2.k8s.ooo port 8080 after 12 ms: Connection refused
* Closing connection 0
curl: (7) Failed to connect to wa1-front.default.svc.c2.k8s.ooo port 8080 after 12 ms: Connection refused
[13:36] nb3:workadventure%

```

Fixed: it is listening on port 80.

#### Network error

* Seems like the pusher cannot be reached: https://issueexplorer.com/issue/thecodingmachine/workadventure/1481
* Pusher is not reachable


#### Pusher does not respond

* Needed to fix the service definition, reachable now

```
[13:42] nb3:workadventure% curl -v http://wa1-pusher.default.svc.c2.k8s.ooo:8080
*   Trying 2a0a:e5c0:13:e2::1488:8080...
* Connected to wa1-pusher.default.svc.c2.k8s.ooo (2a0a:e5c0:13:e2::1488) port 8080 (#0)
> GET / HTTP/1.1
> Host: wa1-pusher.default.svc.c2.k8s.ooo:8080
> User-Agent: curl/7.80.0
> Accept: */*
>
* Empty reply from server
* Closing connection 0
curl: (52) Empty reply from server
```


### v4: helm re-usable
