## c0.k8s.ooo

Base cluster for managing other clusters.

## Bootstrap Control Plane

* apu1: `kubeadm init --config k8s/c0/kubeadm.yaml  --upload-certs`
* apu2: `kubeadm join api.c0.k8s.ooo:6443 ...`
* apu3: `kubeadm join api.c0.k8s.ooo:6443 ...`

Removing taints, self contained cluster:

```
kubectl taint nodes --all node-role.kubernetes.io/master-
```

## Bootstrapping networking

```
mount --make-shared /sys
mount --make-shared /run
kubectl apply -f v3-calico/calico.yaml
kubectl apply -f https://docs.projectcalico.org/manifests/calicoctl.yaml

alias calicoctl="kubectl exec -i -n kube-system calicoctl -- /calicoctl"
calicoctl create -f - < ./k8s/c0/calico-bgp.yaml
```

## Flux bootstrap

On a client:

```
wget https://github.com/fluxcd/flux2/releases/download/v0.16.1/flux_0.16.1_linux_amd64.tar.gz
tar xvfz flux_0.16.1_linux_amd64.tar.gz
./flux bootstrap git --path=./cluster/c0 --cluster-domain c0.k8s.ooo --url ssh://git@code.ungleich.ch/ungleich-intern/k8s-config.git --branch=main
```

## rook bootstrap

* via flux
